#version 430 core

layout (location = 0) in vec3 aPos;
layout (location = 1) in vec3 aNormal;

uniform mat4 model;
uniform mat4 view;
uniform mat4 projection;

out vec3 normal;
out vec3 position;

void main()
{
    normal = mat3(transpose(inverse(model))) * aNormal; 
    position = vec3(model * vec4(aPos, 1.0));           
    gl_Position = projection * view * vec4(position, 1.0);  
}